import Vue from 'vue'
import co from 'co'
import CryptoJS from 'crypto-js'
import { GanShenMe } from '../util/Util'

// post执行过程`
let postGen = function * (method, url, data, self) {
  if (self.isBusy === true) {
    self.xhr.abort()
  }
  self.isBusy = true
  // 如果需要提醒，显示提醒框
  try {
    let dataRet = yield self.http(method, url, data)
    self.isBusy = false
    return dataRet
  } catch (error) {
    self.isBusy = false
    throw error
  }
}

export default class HttpLoad {

  constructor () {
    this.xhr = new XMLHttpRequest()
    // 设置超时时间, 毫秒
    this.xhr.timeout = 10000
    Vue.set(this, 'isBusy', false)
  }

  load (url, data) {
    let gen = postGen('POST', url, data, this)
    return co(gen)
  }

  // 处理http请求
  http (method, url, body) {
    return new Promise((resolve, reject) => {
      if (!body) {
        body = {}
      }
      if(Vue.mmType){
        if(Vue.mmType=='nginx' && url.indexOf("127.0.0.1") === -1){
          let key = CryptoJS.enc.Utf8.parse(GanShenMe(Vue.HWQMM));
          if((typeof body) === 'string') {
            let srcs = CryptoJS.enc.Utf8.parse(body);
            body = CryptoJS.AES.encrypt(srcs, key, {mode:CryptoJS.mode.ECB,padding: CryptoJS.pad.Pkcs7}).toString();
          } else {
            let srcs = CryptoJS.enc.Utf8.parse(JSON.stringify(body));
            body =CryptoJS.AES.encrypt(srcs, key, {mode:CryptoJS.mode.ECB,padding: CryptoJS.pad.Pkcs7}).toString();
          }
        }
      }
      let self = this
      this.xhr.onload = function () {
          if (this.status === 200) {
            let data = this.responseText
            if(Vue.mmType){
              if(Vue.mmType == 'nginx' && url.indexOf("127.0.0.1") === -1){
                // 匹配到规则，进行$解$密$处$理$
                let key = CryptoJS.enc.Utf8.parse(GanShenMe(Vue.HWQMM));
                data = CryptoJS.AES.decrypt(this.responseText,key,{mode:CryptoJS.mode.ECB,padding: CryptoJS.pad.Pkcs7}).toString(CryptoJS.enc.Utf8)
              }
            }
            try {
              // 根据返回类型，处理返回值
              data = JSON.parse(data)
            } catch (error) {
              data = data
            }
            resolve({data: data})
          } else {
            Vue.console.warn(`http异常, 错误码：${this.status}, 错误信息：${this.response}`, 'HttpLoad')
            reject({status: this.status, data: this.response})
          }
      }
      this.xhr.onabort = function () {
        Vue.console.warn(`请求被终止！`, 'HttpLoad')
        reject({status: 610, data: '请求被终止！'})
      }
      this.xhr.ontimeout = function () {
        Vue.console.warn(`请求超时!`, 'HttpLoad')
        reject({status: 611, data: '请求超时'})
      }
      this.xhr.onerror = function () {
        Vue.console.error(`网络故障!`, 'HttpLoad')
        reject({status: 612, data: '网络故障'})
      }

      Vue.console.info(`http请求: ${url}`, 'HttpLoad')
      this.xhr.open(method, url, true)
      this.xhr.send(JSON.stringify(body))
    })
  }
}
