import Vue from 'vue'

let MessageBox = {
  install (Vue, options) {
    // 给vue增添对话框显示方法
    Vue.showMessage = Vue.prototype.$showMessage = function (msg, buttons = ['confirm'], titlestyle, msgstyle, btnstyle) {
      return new Promise((resolve) => {
        MessageBox.msg = msg
        // 要显示的按钮解析
        MessageBox.confirmShow = false
        MessageBox.cancelShow = false
        for (let bName of buttons) {
          MessageBox[`${bName}Show`] = true
        }
        titlestyle ? MessageBox.titlestyle = titlestyle : MessageBox.titlestyle = ''
        msgstyle ? MessageBox.msgstyle = msgstyle : MessageBox.msgstyle = ''
        btnstyle ? MessageBox.btnstyle = btnstyle : MessageBox.btnstyle = ''
        setTimeout(() => {
          MessageBox.show = true
        }, 300)
        MessageBox.resolve = resolve
      })
    }

    Vue.showMessageWithSize = Vue.prototype.$showMessageWithSize = function (msg, buttons = ['confirm'], size) {
      return new Promise((resolve) => {
        MessageBox.msg = msg
        // 要显示的按钮解析
        MessageBox.confirmShow = false
        MessageBox.cancelShow = false
        for (let bName of buttons) {
          MessageBox[`${bName}Show`] = true
        }
        let msgsize = 'font-size:' + size
        MessageBox.titlestyle = msgsize
        MessageBox.msgstyle = msgsize
        MessageBox.btnstyle = msgsize
        setTimeout(() => {
          MessageBox.show = true
        }, 300)
        MessageBox.resolve = resolve
      })
    }

    // 给vue增添对话框关闭方法
    Vue.closeMessage = Vue.prototype.$closeMessage = function () {
      MessageBox.show = false
    }
  }
}

Vue.set(MessageBox, 'show', false)
Vue.set(MessageBox, 'msg', '')
Vue.set(MessageBox, 'confirmShow', false)
Vue.set(MessageBox, 'cancelShow', false)
Vue.set(MessageBox, 'titlestyle', '')
Vue.set(MessageBox, 'msgstyle', '')
Vue.set(MessageBox, 'btnstyle', '')

export default MessageBox
