import Vue from 'vue'
import all from 'src/all'
import co from 'co'

let testGen = function * (done) {
  try {
    yield Vue.resetpost('http://1', {})
  } catch (error) {
    done()
  }
}

let test = async function (done) {
  try {
    await Vue.resetpost('http://1', {})
  } catch (error) {
    done()
  }
}

describe('HttpReset: 发送请求', () => {
  before(() => {
    all()
  })

  it('请求异常，await', done => {
    test(done)
  })

  it('请求异常，co', done => {
    let gen = testGen(done)
    co(gen)
  })

  it('发送错误Token', async function() {
    Vue.$login = {jwt: 'aaaa'}
    try {
      await Vue.resetpost('/rs/report/card_bill', {"data": {"condition":"53"}}, { rejectMsg: null, resolveMsg: null })
    } catch (error) {
      assert.equal(error.status, 500)
      assert.isAbove(error.data.length, 200)
    }
  })

  it('发送跨域请求', async function() {
    Vue.$login = {jwt: 'aaaa'}
    try {
      await Vue.resetpost('http://127.0.0.1:8003/test', {data: {}}, { rejectMsg: null, resolveMsg: null })
    } catch (error) {
      assert.equal(error.status, 612)
      assert.isAbove(error.data.length, 0)
    }
  })
})

// also see example testing a component with mocks at
// https://github.com/vuejs/vue-loader-example/blob/master/test/unit/a.spec.js#L24-L49
